--
-- ABORT and ROLLBACK
--

CREATE TABLE aborttest (
   i1 integer,
   d1 double precision,
   t1 text
);

INSERT INTO aborttest (i1, d1, t1) VALUES (123, 456.789, 'first row');
INSERT INTO aborttest VALUES (456, 789.012, 'second row');

SELECT ALL * FROM aborttest;

BEGIN;

CREATE TABLE aborttest2 (a int4);

DELETE FROM aborttest;

-- should be empty
SELECT DISTINCT * FROM aborttest;

ABORT;

-- should not exist 
SELECT oid FROM pg_class WHERE relname = 'aborttest2';

-- should have members again 
SELECT * FROM aborttest;


BEGIN TRANSACTION;

CREATE TABLE aborttest2 (a int4);

DELETE FROM aborttest;

-- should be empty
SELECT * FROM aborttest;

ABORT TRANSACTION;

-- should not exist 
SELECT oid FROM pg_class WHERE relname = 'aborttest2';

-- should have members again 
SELECT * FROM aborttest;

BEGIN WORK;

CREATE TABLE aborttest2 (a int4);

DELETE FROM aborttest;

-- should be empty
SELECT * FROM aborttest;

ABORT WORK;

-- should not exist 
SELECT oid FROM pg_class WHERE relname = 'aborttest2';

-- should have members again 
SELECT * FROM aborttest;

BEGIN WORK;

CREATE TABLE aborttest2 (a int4);

DELETE FROM aborttest;

-- should be empty
SELECT * FROM aborttest;

ROLLBACK WORK;
ABORT WORK; --error : no need to abort after rollback

-- should not exist 
SELECT oid FROM pg_class WHERE relname = 'aborttest2';

-- should have members again 
SELECT * FROM aborttest;

BEGIN TRANSACTION;

CREATE TABLE aborttest2 (a int4);

DELETE FROM aborttest;

-- should be empty
SELECT * FROM aborttest;

ROLLBACK TRANSACTION;

-- should not exist 
SELECT oid FROM pg_class WHERE relname = 'aborttest2';

-- should have members again 
SELECT * FROM aborttest;

BEGIN;

CREATE TABLE aborttest2 (a int4);

DELETE FROM aborttest;

-- should be empty
SELECT * FROM aborttest;

ROLLBACK;

-- should not exist 
SELECT oid FROM pg_class WHERE relname = 'aborttest2';

-- should have members again 
SELECT * FROM aborttest;

ABORT; -- error: no transaction in progress
ABORT this; -- error: extra argument

DROP TABLE aborttest;
