--
-- USER
--

/* CREATE USER tests */
CREATE USER rhdb1;
CREATE USER rhdb2;
CREATE USER rhdb3 with PASSWORD 'afeiofan';
-- to change a user password
ALTER USER rhdb1 WITH PASSWORD 'ke2fv9a';
-- to allow a user to create database
ALTER USER rhdb1 CREATEDB;
-- to disallow a user to create database
ALTER USER rhdb1 NOCREATEDB;
-- to allow a user to create user
ALTER USER rhdb1 CREATEUSER;
-- to disallow a user to create user
ALTER USER rhdb1 NOCREATEUSER;
-- to change a user's valid until date
ALTER USER rhdb1 VALID UNTIL 'Dec 31 2050';
-- to change a user's valid until date to be Dec 31 2099 midnight using
-- the time zone which is 4 hours behind of UTC
ALTER USER rhdb1 VALID UNTIL 'Dec 31 0:00:00 2099 -4';
ALTER USER rhdb2 WITH PASSWORD 'aiewfk' CREATEDB NOCREATEUSER VALID UNTIL 'Dec 31 2050';

/* ALTER USER tests with invalid arguments */
ALTER USER rhdb2 WITH PASSWORD; -- error: missing password string
ALTER USER rhdb4 CREATEUSER; -- error: user doesn't exist

-- drop user
DROP USER rhdb1;
DROP USER rhdb2;
DROP USER rhdb3;
